// Copyleft (Cl) 1999 by Malekith / The Final Crash of Corp. System
// <malekith@topnet.pl> / <http://malekith.topnet.pl>
// This is part of gallery image viewer. See file copying-left for details.
// $Id: color-parse.c,v 1.7 1999/12/11 21:54:13 malekith Exp malekith $

// I had to rewrite color parsing procedure from X, because
// this great prog must be runnable on X-less system

#include "main-c.h"
#include "color-parse.h"
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>

#ifndef TRUE
#	define TRUE 1
#endif
#ifndef FALSE
#	define FALSE 0
#endif

typedef struct _XColor
{
	char * name;
	unsigned char red, green, blue;
} XColor;
#include "xcolors.c"

static int hex(char p)
{
	if (p >= 'a') return p-'a'+10;
	else return p-'0';
}
int my_color_parse(const char * name, GdkColor * c)
{
	char * lowname;
	char * p;
	XColor * cp = xcolors;
	
	lowname = strdup(name);
	p = lowname;
	while (*p) *p++ = tolower(*p);
	if (lowname[0]=='#') {
		int n = strlen(lowname)-1;
		int k = n / 3;
		p = lowname + 1;
		
		if (k==1) {
			c->red = hex(*p++) << 12;
			c->green = hex(*p++) << 12;
			c->blue = hex(*p++) << 12;
			return TRUE;
		} else {
			c->red = hex(*p++) << 12;
			c->red += hex(*p++) << 8;
			p += k-2;
			c->green = hex(*p++) << 12;
			c->green += hex(*p++) << 8;
			p += k-2;
			c->blue = hex(*p++) << 12;
			c->blue += hex(*p++) << 8;
			return TRUE;
		}
	}	
	if (strncmp(lowname,"rgb",3) == 0) {
		if (lowname[3] == 'i') {
			float r,g,b;
			sscanf(lowname+5, "%f/%f/%f", &r, &g, &b);
			r *= 0x10000;
			g *= 0x10000;
			b *= 0x10000;
			c->red = r;
			c->green = g;
			c->blue = b;
			return TRUE;
		} else {
			p = lowname+4;
			c->red = hex(*p++) << 12;
			if (*p!='/') c->red += hex(*p++) << 8;
			while (*p++!='/') { }
			c->green = hex(*p++) << 12;
			if (*p!='/') c->green += hex(*p++) << 8;
			while (*p++!='/') { }
			c->blue = hex(*p++) << 12;
			if (*p!='/') c->blue += hex(*p++) << 8;
			return TRUE;
		}
	}
	while (cp->name)
		if (strcmp(cp++->name, lowname) == 0)
			break;
	free(lowname);
	if (cp->name) {
		c->red = c->red << 8;
		c->green = c->green << 8;
		c->blue = c->blue << 8;
		return TRUE;
	} else
		return FALSE;
}
