// Copyleft (Cl) 1999 by Malekith / The Final Crash of Corp. System
// <malekith@topnet.pl> / <http://malekith.topnet.pl>
// This is part of gallery image viewer. See file copying-left for details.
// $Id: iff.cc,v 2.5 1999/12/11 21:54:13 malekith Exp malekith $

#include "main.h"
#include "iff.h"
#include "iff-pbm.h"

// ----------------------------------------------------------------------------
extern "C" void ilbm_set_size(void *thiz, int w, int h, int exRGB, int isG,
			      int alpha)
{
	((IffImage *) thiz)->set_size(w, h, exRGB, isG, alpha);
}
extern "C" void ilbm_set_cmap(void *thiz, byte *cmap, int ncols)
{
	((IffImage *) thiz)->set_cmap(cmap, ncols);
}
extern "C" void ilbm_put(void *thiz, byte *buf, int line)
{
	((IffImage *) thiz)->put(buf, line);
}
extern "C" void now_doing(int, int);
// ----------------------------------------------------------------------------
void IffImage::set_size(int w, int h, int exRGB, int /*isG*/, int alphap)
{
	set_buffers(this, exRGB ? (alphap ? dtRGBA : dtRGB) : dtPalette, 
		    w, h, 30);
}
// ----------------------------------------------------------------------------
void IffImage::set_cmap(byte *cmap, int ncols)
{
	memcpy(palette, cmap, (ncols*3) <? (256*3));
}
// ----------------------------------------------------------------------------
void IffImage::put(byte *buf, int line)
{
	memcpy(data+line*line_width,buf,line_width);	
}
// ----------------------------------------------------------------------------
IffImage::IffImage() : Image("*.iff", "*.ilbm", "*.ilb", "*.lbm")
{
	fmt_name = "IFF";
	fmt_cmt = "Amiga Interchange File Format";
	fmt_src = N_("GIMP plugin by Johnny Teveen (IFF/ILBM) and "
	"Allegro Library by Shawn Hargreaves, loader by "
	"Adrian Oboroc (IFF/PBM).");
	magic = "FORM";
}
// ----------------------------------------------------------------------------
extern "C" int loadImage(void *thiz, const char *filename);
void IffImage::read_ilbm()
{
	loadImage(this, file_name);
}
// ----------------------------------------------------------------------------
void IffImage::read_pbm()
{
	const int FALSE = 0;
	image_info g;
	if (iff_pbm_get_header(file_name, &g) == false)
		throw xIff("iff_pbm_get_header()");

	int w = g.width, h = g.height;

	if (g.bpp > 8) {
		// !!!!!!!!!!!!!!!!!
		abort(); // not supported yet!
		// !!!!!!!!!!!!!!!!!
	}
	set_buffers(this,dtPalette,w,h,0);
	if (iff_pbm_load(file_name, data_size, data, palette) == FALSE) 
		throw xIff("iff_pbm_load()");
}
// ----------------------------------------------------------------------------
// i know, i should put pbm loader into ilbm loader code, but i'm lazy 
// and don't know (or i'm too lazy to find out...) how does it work ;))))
void IffImage::do_read()
{
	FILE *f = fopen(file_name,"r");
	if (!f)
		throw xIff("no such file");
	char buf[12] = {0};
	fread(buf,sizeof(buf),1,f);
	fclose(f);
	if (!strncmp(buf+8,"PBM ",4))
		read_pbm();
	else
		read_ilbm();
}
// ----------------------------------------------------------------------------
