/* this module has been taken from */
/*
 * GTK See -- a image viewer based on GTK+
 * Copyright (C) 1998 Hotaru Lee <jkhotaru@mail.sti.com.cn> <hotaru@163.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/* 
 * and slighty modified by Malekith 
 * $Id: im_pcx.h,v 1.5 1999/09/05 18:49:59 malekith Exp malekith $
 */

#ifndef __IM_PCX_H__
#define __IM_PCX_H__

#ifdef __cplusplus
	extern "C" {
#endif /* __cplusplus */

#include "sim_gtk.h"

gboolean	pcx_get_header		(gchar *filename, image_info *info);
gboolean	pcx_load		(gchar *filename, int bsize, guchar * buffer, guchar * pal_buf);

typedef struct {
    guint8 manufacturer;
    guint8 version;
    guint8 compression;
    guint8 bpp;
    gint16 x1, y1;
    gint16 x2, y2;
    gint16 hdpi;
    gint16 vdpi;
    guint8 colormap[48];
    guint8 reserved;
    guint8 planes;
    gint16 bytesperline;
    gint16 color;
    guint8 filler[58];
} __attribute__ ((packed)) pcx_header_struct;

#ifdef __cplusplus
	}
#endif /* __cplusplus */

#endif

