// Copyleft (Cl) 1999 by Malekith / The Final Crash of Corp. System
// <malekith@topnet.pl> / <http://malekith.topnet.pl>
// This is part of gallery image viewer. See file copying-left for details.
// Created on Aug 10 1999
// $Id: image.cc,v 2.6 1999/12/11 21:54:13 malekith Exp malekith $

#include "main.h"
#include "image.h"
#include <vgagl.h>
#include <fnmatch.h>

// ---------------------------------------------------------------------------
// globals
const byte black_palette[256*3]; 
// ---------------------------------------------------------------------------
void Bitmap::free()
{
	delete [] buf;
	buf = null;
	w = 0;
	h = 0;
}
// ---------------------------------------------------------------------------
Bitmap::~Bitmap()
{
	free();
}
// ---------------------------------------------------------------------------
void Bitmap::alloc(int x, int y)
{
	free();
	w = x; wbpp = w * bytespp;
	h = y;
	buf = new byte[w * h * bytespp];
}
// ---------------------------------------------------------------------------
void Bitmap::put(Bitmap & target)
{
	memset(target.data(), 0, target.width() * target.height() * bytespp);
	int n = (height()+y <? target.height()) - y;
	int b = ((width()+x <? target.width()) - x) * bytespp;
	byte * d = target.data() + (x + y * target.width()) * bytespp;
	byte * s = data();
	while (n-- > 0) {
		memcpy(d, s, b);
		d += target.line_width();
		s += line_width();
	}
}
// ---------------------------------------------------------------------------
void Bitmap::resize_from(const Bitmap & target)
{
	assert(buf);
	assert(target.buf);
	gl_scalebox(	target.w, target.h, target.buf,
			w, h, buf
			);
}
// ---------------------------------------------------------------------------
void Bitmap::copy_from(const Bitmap & src)
{
	alloc(src.w, src.h);
	memcpy(buf, src.buf, wbpp*h);
}
// ---------------------------------------------------------------------------
void Bitmap::put()
{
	gl_enableclipping();
	gl_putbox(-x, -y, w, h, buf);
}
// ---------------------------------------------------------------------------
Image::Image(const char * p1, const char * p2, const char * p3, 
	     const char * p4, const char * p5, const char * p6)
: magic(null), file_is_temp(false), file_name(null)
{ 
	patterns[0] = p1;
	patterns[1] = p2;
	patterns[2] = p3;
	patterns[3] = p4;
	patterns[4] = p5;
	patterns[5] = p6;
}
// ---------------------------------------------------------------------------
bool Image::match_name(const char * fname)
{
	const char ** p = patterns;
	while (*p) {
		if (fnmatch(*p, fname, FNM_LEADING_DIR | FNM_CASEFOLD) == 0)
			return true;
		p++;
	}
	return false;
}
// ---------------------------------------------------------------------------
bool Image::match_magic(const byte * buffer)
{
	return magic && (strncmp((const char*)buffer, 
				 magic, 
				 strlen(magic)) == 0);
}
// ---------------------------------------------------------------------------
extern "C" void now_doing(int,int);
void Image::read()
{
	now_doing(0,100); // default
	do_read();
	clear_temp();
}
// ---------------------------------------------------------------------------
void Image::clear_temp()
{
	if (file_is_temp) {
		if (strncmp(file_name, "/tmp", 4) != 0)
			throw xRecover(_("won't delete file 'cause it don't "
				"looks like temp")); // should never happen
		remove(file_name);
		file_is_temp = false;
	}
}
// ---------------------------------------------------------------------------
