// Copyleft (Cl) 1999 by Malekith / The Final Crash of Corp. System
// <malekith@topnet.pl> / <http://malekith.topnet.pl>
// This is part of gallery image viewer. See file copying-left for details.
// Created on Aug 12 1999
// $Id: message.cc,v 2.13 1999/12/11 21:54:13 malekith Exp malekith $


#include "main.h"
#include "image.h"
#include "browser.h"

#include <stdarg.h>
#include <ctype.h>
#include <vgagl.h>

#define MESSAGE_SCREEN PREFIX "/lib/" NAME "/message.jpg"

void fmt_text(int maxn, char * s)
{
	char * last = s;
	int n = 0;
	bool escape = false;
	while (*s) {
		if (*s == '\n')
			n = 0;
		else if (isspace(*s))
			last = s;
		if (n > maxn) {
			*last = '\n';
			n = s - last;
			last = s;
		}
		if (s[0] == '\e' && s[1] == '[')
			escape = true;
		s++;
		if (!escape)
			n++;
		if (escape && *s == 'm')
			escape = false;
	}
}
void Browser::message(const char *fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
	char *p;
	vasprintf(&p, fmt, ap);
	va_end(ap);
	bool image_set = false;
	try {
		if (show_message_screen) {
			orig_file_name = MESSAGE_SCREEN;
			read();
			on_screen.resize_from(orig,screen_w, screen_h);
			update_screen(true);
			image_set = true;
		}
	}
	catch (xRecover &) {
	}
	if (!image_set) {
		gl_clearscreen(0);
		if (bitspp == 8) {
			gl_setfontcolors(0, 1);
			gl_setpalettecolor(1, 63, 0, 0);
		} else
			gl_setfontcolors(0, gl_rgbcolor(0xff,0,0));
		
		dirty = Rect(screen_w, screen_h);
	} else
		gl_setfontcolors(0, rgbcolor(0xff,0xff,0xff));
		
	fprintf(stderr,"%s\n",p); // additional log
	
	fmt_text((500 * screen_w / 640) / 8, p);
	
	int x = 70 * screen_w / 640;
	int y = 140 * screen_h / 480;
	gl_printf(x, y, p);
	
	free(p); 
}
