// Copyleft (Cl) 1999 by Malekith / The Final Crash of Corp. System
// <malekith@topnet.pl> / <http://malekith.topnet.pl>
// This is part of gallery image viewer. See file copying-left for details.
// $Id: pcx.cc,v 2.3 1999/12/11 21:54:13 malekith Exp malekith $

#include "main.h"
#include "pcx.h"

#include "im_pcx.h"

extern "C" void now_doing(int,int);
// ----------------------------------------------------------------------------
PcxImage::PcxImage() : Image("*.pcx")
{
	fmt_name = "PCX";
	fmt_cmt = "paintbrush PCX";
	fmt_src = N_("GTK See by Hotaru Lee.");
}
// ----------------------------------------------------------------------------
// pcx has very little magic, so we're going to make some additional tests...
bool PcxImage::match_magic(const byte * buffer)
{
	const pcx_header_struct * p = (const pcx_header_struct *) buffer;
	return p->manufacturer == 10 && p->x1 < p->x2 && p->y1 < p->y2 &&
		(p->bpp == 1 || p->bpp == 8) &&
		(p->planes == 1 || p->planes == 3 || p->planes == 4); 
}
// ----------------------------------------------------------------------------
void PcxImage::do_read()
{
	image_info g;
	if (pcx_get_header(file_name, &g) == false)
		throw xPcx("pcx_get_header()");

	int w = g.width, h = g.height;
	set_buffers(this, g.bpp > 8 ? dtRGB : dtPalette, w, h, 30);
	
	if (pcx_load(file_name, data_size, data, palette) == FALSE)
		throw xPcx("pcx_load()");
}
// ----------------------------------------------------------------------------
