// Copyleft (Cl) 1999 by Malekith / The Final Crash of Corp. System
// <malekith@topnet.pl> / <http://malekith.topnet.pl>
// This is part of gallery image viewer. See file copying-left for details.
// $Id: pnm.cc,v 2.3 1999/12/11 21:54:13 malekith Exp malekith $

#include "main.h"
#include "pnm.h"

#include "im_pnm.h"

extern "C" void now_doing(int,int);
// ----------------------------------------------------------------------------
PnmImage::PnmImage() : Image("*.pnm", "*.pgm", "*.pbm", "*.ppm")
{
	fmt_name = "PNM PGM PBM PPM";
	fmt_cmt = "Protable Any/Gray/Bit/Pixel Map";
	fmt_src = N_("GTK See by Hotaru Lee.");
}
// ----------------------------------------------------------------------------
bool PnmImage::match_magic(const byte * buffer)
{
	if (buffer[0] == 'P' && buffer[1] >= '1' && buffer[1] <= '6')
		return true;
	else
		return false;
}
// ----------------------------------------------------------------------------
void PnmImage::do_read()
{
	image_info g;
	if (pnm_get_header(file_name, &g) == false)
		throw xPnm("pnm_get_header()");

	int w = g.width, h = g.height;
	set_buffers(this, g.bpp > 8 ? dtRGB : dtPalette, w, h, g.slow ? 60 : 30);
	
	if (pnm_load(file_name, data_size, data, palette) == FALSE)
		throw xPnm("pnm_load()");
}
// ----------------------------------------------------------------------------
