// Copyleft (Cl) 1999 by Malekith / The Final Crash of Corp. System
// <malekith@topnet.pl> / <http://malekith.topnet.pl>
// This is part of gallery image viewer. See file copying-left for details.
// $Id: targa.cc,v 2.4 1999/12/11 21:54:13 malekith Exp malekith $

#include "main.h"
#include "targa.h"

#include "tga.h"

extern "C" void now_doing(int,int);
// ----------------------------------------------------------------------------
TargaImage::TargaImage() : Image("*.tga", "*.targa")
{
	fmt_name = "TGA";
	fmt_cmt = "Truevision Targa";
	fmt_src = N_("Allegro Library by Shawn Hargreaves. TGA loader by "
	"Tim Gunn. RLE support added by Michal Mertl and "
	"Salvador Eduardo Tropea. Modified.");
}
// ----------------------------------------------------------------------------
// tga has no magic -- it's phisical and doesn't even think about fireballs
bool TargaImage::match_magic(const byte * )
{
	return false;
}
// ----------------------------------------------------------------------------
void TargaImage::do_read()
{
	image_info g;
	if (tga_get_header(file_name, &g) == false)
		throw xTarga("tga_get_header()");

	int w = g.width, h = g.height;
	set_buffers(this, g.bpp > 8 ? dtRGB : dtPalette, w, h, 30);
	
	if (tga_load(file_name, data_size, data, palette) == false)
		throw xTarga("tga_load()");
}
// ----------------------------------------------------------------------------
