// Copyleft (Cl) 1999 by Malekith / The Final Crash of Corp. System
// <malekith@topnet.pl> / <http://malekith.topnet.pl>
// This is part of gallery image viewer. See file copying-left for details.
// $Id: tiff.cc,v 2.5 1999/12/11 21:54:13 malekith Exp malekith $

#include "main.h"

#ifdef HAVE_LIBTIFF

#include "tiff.h"
#include <tiffio.h>

extern "C" void now_doing(int,int);
// --------------------------------------------------------------------------
TiffImage::TiffImage() : Image("*.tif", "*.tiff") 
{ 
	fmt_name = "TIFF";
	fmt_cmt = "Tagged Image File Format";
	fmt_src = N_("libtiff by Sam Leffler & SGI");
}
// --------------------------------------------------------------------------
bool TiffImage::match_magic(const byte * buffer)
{
	// big-endian, `M'otorola
	if (buffer[0] == 'M' && buffer[1] == 'M' &&
	    buffer[2] == 0 && buffer[3] == 42)
		return true;
	// little-endian, `I'ntel
	if (buffer[0] == 'I' && buffer[1] == 'I' &&
	    buffer[2] == 42 && buffer[3] == 0)
		return true;
	return false;
}
// --------------------------------------------------------------------------
void TiffImage::do_read()
{
	TIFF *tif = TIFFOpen(file_name, "r");
	if (tif == null)
		throw xTiff(_("can't open tiff file"));
	uint32 w, h;
	TIFFGetField(tif, TIFFTAG_IMAGEWIDTH, &w);
	TIFFGetField(tif, TIFFTAG_IMAGELENGTH, &h);
	if (w <= 0 || h <= 0) {
		TIFFClose(tif);
		throw xTiff(_("w || h out of range"));
	}
	set_buffers(this, dtRGBA_ud, w, h, 60);
	
	if (!TIFFReadRGBAImage(tif, w, h, (uint32*) data, 0)) {
		TIFFClose(tif);
		throw xTiff("TIFFReadRGBAImage()");
	}
	TIFFClose(tif);
}
// --------------------------------------------------------------------------

#endif