// Copyleft (Cl) 1999 by Malekith / The Final Crash of Corp. System
// <malekith@topnet.pl> / <http://malekith.topnet.pl>
// This is part of gallery image viewer. See file copying-left for details.
// $Id: xbm.cc,v 2.3 1999/12/11 21:54:13 malekith Exp malekith $

#include "main.h"
#include "xbm.h"
#include "im_xbm.h"

#include <ctype.h>

// ----------------------------------------------------------------------------
XbmImage::XbmImage() : Image("*.xbm")
{
	fmt_name = "XBM";
	fmt_cmt = "X bitmap";
	fmt_src = N_("GTK See by Hotaru Lee. Originally from GIMP, (c) Gordon Matzigkeit");
}
// ----------------------------------------------------------------------------
bool XbmImage::match_magic(const byte * buffer)
{
	const char * p = (const char *) buffer;
	int n = 1000;
	while (n > 0) {
	while (n-- > 0 && *p && isspace(*p))
		p++;
	if (p[0] == '/' && p[1] == '*') {
		while(n-- > 0) {
			if (p[0] == '*' && p[1] == '/')
				break;
			p++;
		}
	}
	}
	if (n < 0) return false;
	// of course that way any C source could be matched ...
	if (strncmp(p,"#define",7) == 0)
		return true;
	else
		return false;
}
// ----------------------------------------------------------------------------
void XbmImage::do_read()
{
	image_info g;
	if (xbm_get_header(file_name, &g) == false)
		throw xXbm("xbm_get_header()");

	int w = g.width, h = g.height;
	set_buffers(this, dtPalette, w, h, 0);
	
	if (xbm_load(file_name, data_size, data, palette) == FALSE)
		throw xXbm("xbm_load()");
}
// ----------------------------------------------------------------------------
